const characterList = [
    {
        id: "9e3f7ce4-b9a7-4244-b709-dae5c1f1d4a8",
        name: "Harry Potter",
        alternate_names: ["The Boy Who Lived", "The Chosen One"],
        species: "human",
        gender: "male",
        house: "Gryffindor",
        dateOfBirth: "31-07-1980",
        yearOfBirth: 1980,
        wizard: true,
        ancestry: "half-blood",
        eyeColour: "green",
        hairColour: "black",
        wand: {
            wood: "holly",
            core: "phoenix feather",
            length: 11,
        },
        patronus: "stag",
        hogwartsStudent: true,
        hogwartsStaff: false,
        actor: "Daniel Radcliffe",
        alternate_actors: [],
        alive: true,
        image: "https://ik.imagekit.io/hpapi/harry.jpg",
    },
    {
        id: "4c7e6819-a91a-45b2-a454-f931e4a7cce3",
        name: "Hermione Granger",
        alternate_names: [],
        species: "human",
        gender: "female",
        house: "Gryffindor",
        dateOfBirth: "19-09-1979",
        yearOfBirth: 1979,
        wizard: true,
        ancestry: "muggleborn",
        eyeColour: "brown",
        hairColour: "brown",
        wand: {
            wood: "vine",
            core: "dragon heartstring",
            length: 10.75,
        },
        patronus: "otter",
        hogwartsStudent: true,
        hogwartsStaff: false,
        actor: "Emma Watson",
        alternate_actors: [],
        alive: true,
        image: "https://ik.imagekit.io/hpapi/hermione.jpeg",
    },
    {
        id: "c3b1f9a5-b87b-48bf-b00d-95b093ea6390",
        name: "Ron Weasley",
        alternate_names: ["Dragomir Despard"],
        species: "human",
        gender: "male",
        house: "Gryffindor",
        dateOfBirth: "01-03-1980",
        yearOfBirth: 1980,
        wizard: true,
        ancestry: "pure-blood",
        eyeColour: "blue",
        hairColour: "red",
        wand: {
            wood: "willow",
            core: "unicorn tail-hair",
            length: 14,
        },
        patronus: "Jack Russell terrier",
        hogwartsStudent: true,
        hogwartsStaff: false,
        actor: "Rupert Grint",
        alternate_actors: [],
        alive: true,
        image: "https://ik.imagekit.io/hpapi/ron.jpg",
    },
    {
        id: "af95bd8a-dfae-45bb-bc69-533860d34129",
        name: "Draco Malfoy",
        alternate_names: [],
        species: "human",
        gender: "male",
        house: "Slytherin",
        dateOfBirth: "05-06-1980",
        yearOfBirth: 1980,
        wizard: true,
        ancestry: "pure-blood",
        eyeColour: "grey",
        hairColour: "blonde",
        wand: {
            wood: "hawthorn",
            core: "unicorn tail-hair",
            length: 10,
        },
        patronus: "",
        hogwartsStudent: true,
        hogwartsStaff: false,
        actor: "Tom Felton",
        alternate_actors: [],
        alive: true,
        image: "https://ik.imagekit.io/hpapi/draco.jpg",
    },
    {
        id: "ca3827f0-375a-4891-aaa5-f5e8a5bad225",
        name: "Minerva McGonagall",
        alternate_names: [],
        species: "human",
        gender: "female",
        house: "Gryffindor",
        dateOfBirth: "04-10-1925",
        yearOfBirth: 1925,
        wizard: true,
        ancestry: "half-blood",
        eyeColour: "",
        hairColour: "black",
        wand: {
            wood: "fir",
            core: "dragon heartstring",
            length: 9.5,
        },
        patronus: "tabby cat",
        hogwartsStudent: false,
        hogwartsStaff: true,
        actor: "Dame Maggie Smith",
        alternate_actors: [],
        alive: true,
        image: "https://ik.imagekit.io/hpapi/mcgonagall.jpg",
    },
    {
        id: "d5c4daa3-c726-426a-aa98-fb40f3fba816",
        name: "Cedric Diggory",
        alternate_names: [],
        species: "human",
        gender: "male",
        house: "Hufflepuff",
        dateOfBirth: null,
        yearOfBirth: 1977,
        wizard: true,
        ancestry: "",
        eyeColour: "grey",
        hairColour: "brown",
        wand: {
            wood: "ash",
            core: "unicorn hair",
            length: 12.25,
        },
        patronus: "",
        hogwartsStudent: true,
        hogwartsStaff: false,
        actor: "Robert Pattinson",
        alternate_actors: [],
        alive: false,
        image: "https://ik.imagekit.io/hpapi/cedric.png",
    },
    {
        id: "8f9aa40b-5d7c-441e-ad32-4564ecda3b70",
        name: "Cho Chang",
        alternate_names: [],
        species: "human",
        gender: "female",
        house: "Ravenclaw",
        dateOfBirth: "07-04-1979",
        yearOfBirth: 1979,
        wizard: true,
        ancestry: "",
        eyeColour: "brown",
        hairColour: "black",
        wand: {
            wood: "",
            core: "",
            length: null,
        },
        patronus: "swan",
        hogwartsStudent: true,
        hogwartsStaff: false,
        actor: "Katie Leung",
        alternate_actors: [],
        alive: true,
        image: "https://ik.imagekit.io/hpapi/cho.jpg",
    },
    {
        id: "3569d265-bd27-44d8-88e8-82fb0a848374",
        name: "Severus Snape",
        alternate_names: ["Half-Blood Prince"],
        species: "human",
        gender: "male",
        house: "Slytherin",
        dateOfBirth: "09-01-1960",
        yearOfBirth: 1960,
        wizard: true,
        ancestry: "half-blood",
        eyeColour: "black",
        hairColour: "black",
        wand: {
            wood: "",
            core: "",
            length: null,
        },
        patronus: "doe",
        hogwartsStudent: false,
        hogwartsStaff: true,
        actor: "Alan Rickman",
        alternate_actors: [],
        alive: false,
        image: "https://ik.imagekit.io/hpapi/snape.jpg",
    },
    {
        id: "36bfefd0-e0bb-4d11-be98-d1ef6117a77a",
        name: "Rubeus Hagrid",
        alternate_names: [],
        species: "half-giant",
        gender: "male",
        house: "Gryffindor",
        dateOfBirth: "06-12-1928",
        yearOfBirth: 1928,
        wizard: true,
        ancestry: "half-blood",
        eyeColour: "black",
        hairColour: "black",
        wand: {
            wood: "oak",
            core: "",
            length: 16,
        },
        patronus: "",
        hogwartsStudent: false,
        hogwartsStaff: true,
        actor: "Robbie Coltrane",
        alternate_actors: [],
        alive: true,
        image: "https://ik.imagekit.io/hpapi/hagrid.png",
    },
    {
        id: "3db6dc51-b461-4fa4-a6e4-b1ff352221c5",
        name: "Neville Longbottom",
        alternate_names: [],
        species: "human",
        gender: "male",
        house: "Gryffindor",
        dateOfBirth: "30-07-1980",
        yearOfBirth: 1980,
        wizard: true,
        ancestry: "pure-blood",
        eyeColour: "",
        hairColour: "blonde",
        wand: {
            wood: "cherry",
            core: "unicorn tail-hair",
            length: 13,
        },
        patronus: "Non-Corporeal",
        hogwartsStudent: true,
        hogwartsStaff: false,
        actor: "Matthew Lewis",
        alternate_actors: [],
        alive: true,
        image: "https://ik.imagekit.io/hpapi/neville.jpg",
    },
    {
        id: "861c4cde-2f0f-4796-8d8f-9492e74b2573",
        name: "Luna Lovegood",
        alternate_names: [],
        species: "human",
        gender: "female",
        house: "Ravenclaw",
        dateOfBirth: "13-02-1981",
        yearOfBirth: 1981,
        wizard: true,
        ancestry: "",
        eyeColour: "grey",
        hairColour: "blonde",
        wand: {
            wood: "",
            core: "",
            length: null,
        },
        patronus: "hare",
        hogwartsStudent: true,
        hogwartsStaff: false,
        actor: "Evanna Lynch",
        alternate_actors: [],
        alive: true,
        image: "https://ik.imagekit.io/hpapi/luna.jpg",
    },
    {
        id: "1cd6dc64-01a9-4379-9cfd-1a7167ba1bb1",
        name: "Ginny Weasley",
        alternate_names: [],
        species: "human",
        gender: "female",
        house: "Gryffindor",
        dateOfBirth: "11-08-1981",
        yearOfBirth: 1981,
        wizard: true,
        ancestry: "pure-blood",
        eyeColour: "brown",
        hairColour: "red",
        wand: {
            wood: "yew",
            core: "",
            length: null,
        },
        patronus: "horse",
        hogwartsStudent: true,
        hogwartsStaff: false,
        actor: "Bonnie Wright",
        alternate_actors: [],
        alive: true,
        image: "https://ik.imagekit.io/hpapi/ginny.jpg",
    },
    {
        id: "2cfd2d4b-5d1e-4dc5-8837-37a97c7e2f2f",
        name: "Sirius Black",
        alternate_names: ["Padfoot", "Snuffles"],
        species: "human",
        gender: "male",
        house: "Gryffindor",
        dateOfBirth: "03-11-1959",
        yearOfBirth: 1959,
        wizard: true,
        ancestry: "pure-blood",
        eyeColour: "grey",
        hairColour: "black",
        wand: {
            wood: "",
            core: "",
            length: null,
        },
        patronus: "hare",
        hogwartsStudent: false,
        hogwartsStaff: false,
        actor: "Gary Oldman",
        alternate_actors: ["James Walters", "Rohan Gotobed"],
        alive: false,
        image: "https://ik.imagekit.io/hpapi/sirius.JPG",
    },
    {
        id: "b8f9095b-9de6-4d7d-83e0-4391af8f22e4",
        name: "Remus Lupin",
        alternate_names: ["Professor Lupin", "Moony", "Remus John Lupin"],
        species: "werewolf",
        gender: "male",
        house: "Gryffindor",
        dateOfBirth: "10-03-1960",
        yearOfBirth: 1960,
        wizard: true,
        ancestry: "half-blood",
        eyeColour: "green",
        hairColour: "brown",
        wand: {
            wood: "cypress",
            core: "unicorn tail-hair",
            length: 10.25,
        },
        patronus: "wolf",
        hogwartsStudent: false,
        hogwartsStaff: true,
        actor: "David Thewlis",
        alternate_actors: [],
        alive: false,
        image: "https://ik.imagekit.io/hpapi/lupin.jpg",
    },
    {
        id: "dd925874-e800-4eb4-9f0d-4d0fed15634b",
        name: "Arthur Weasley",
        alternate_names: [],
        species: "human",
        gender: "male",
        house: "Gryffindor",
        dateOfBirth: "06-02-1950",
        yearOfBirth: 1950,
        wizard: true,
        ancestry: "pure-blood",
        eyeColour: "blue",
        hairColour: "red",
        wand: {
            wood: "",
            core: "",
            length: null,
        },
        patronus: "weasel",
        hogwartsStudent: false,
        hogwartsStaff: false,
        actor: "Mark Williams",
        alternate_actors: [],
        alive: true,
        image: "https://ik.imagekit.io/hpapi/arthur.jpg",
    },
    {
        id: "6afb1960-febd-418d-b604-e50c1b59459b",
        name: "Bellatrix Lestrange",
        alternate_names: ["Bella"],
        species: "human",
        gender: "female",
        house: "Slytherin",
        dateOfBirth: null,
        yearOfBirth: 1951,
        wizard: true,
        ancestry: "pure-blood",
        eyeColour: "brown",
        hairColour: "black",
        wand: {
            wood: "walnut",
            core: "dragon heartstring",
            length: 12.75,
        },
        patronus: "",
        hogwartsStudent: false,
        hogwartsStaff: false,
        actor: "Helena Bonham Carter",
        alternate_actors: [],
        alive: false,
        image: "https://ik.imagekit.io/hpapi/bellatrix.jpg",
    },
    {
        id: "efa802c8-ae18-4ae1-a524-49df21d05939",
        name: "Lord Voldemort",
        alternate_names: ["Tom Marvolo Riddle"],
        species: "human",
        gender: "male",
        house: "Slytherin",
        dateOfBirth: "31-12-1926",
        yearOfBirth: 1926,
        wizard: true,
        ancestry: "half-blood",
        eyeColour: "red",
        hairColour: "bald",
        wand: {
            wood: "yew",
            core: "phoenix feather",
            length: 13.5,
        },
        patronus: "",
        hogwartsStudent: false,
        hogwartsStaff: false,
        actor: "Ralph Fiennes",
        alternate_actors: [],
        alive: false,
        image: "https://ik.imagekit.io/hpapi/voldemort.jpg",
    },
    {
        id: "2fb675cd-5505-4c8e-a54e-579e73bf4174",
        name: "Horace Slughorn",
        alternate_names: [],
        species: "human",
        gender: "male",
        house: "Slytherin",
        dateOfBirth: null,
        yearOfBirth: null,
        wizard: true,
        ancestry: "pure-blood",
        eyeColour: "green",
        hairColour: "blonde",
        wand: {
            wood: "cedar",
            core: "dragon heartstring",
            length: 10.25,
        },
        patronus: "",
        hogwartsStudent: false,
        hogwartsStaff: true,
        actor: "Jim Broadbent",
        alternate_actors: [],
        alive: true,
        image: "https://ik.imagekit.io/hpapi/slughorn.JPG",
    },
    {
        id: "106cf68d-a86a-415e-ad75-6ad9a4ae24e4",
        name: "Kingsley Shacklebolt",
        alternate_names: [],
        species: "human",
        gender: "male",
        house: "",
        dateOfBirth: null,
        yearOfBirth: null,
        wizard: true,
        ancestry: "pure-blood",
        eyeColour: "brown",
        hairColour: "brown",
        wand: {
            wood: "",
            core: "",
            length: null,
        },
        patronus: "lynx",
        hogwartsStudent: false,
        hogwartsStaff: false,
        actor: "George Harris",
        alternate_actors: [],
        alive: true,
        image: "https://ik.imagekit.io/hpapi/kingsley.jpg",
    },
    {
        id: "d58e7249-19d1-40bd-a43f-1da0497fe8aa",
        name: "Dolores Umbridge",
        alternate_names: [],
        species: "human",
        gender: "female",
        house: "Slytherin",
        dateOfBirth: null,
        yearOfBirth: null,
        wizard: true,
        ancestry: "half-blood",
        eyeColour: "brown",
        hairColour: "grey",
        wand: {
            wood: "birch",
            core: "dragon heartstring",
            length: 8,
        },
        patronus: "persian cat",
        hogwartsStudent: false,
        hogwartsStaff: true,
        actor: "Imelda Staunton",
        alternate_actors: [],
        alive: true,
        image: "https://ik.imagekit.io/hpapi/umbridge.jpg",
    },
    {
        id: "43403619-70cb-4a0c-b70a-6d5cae20e602",
        name: "Lucius Malfoy",
        alternate_names: [],
        species: "human",
        gender: "male",
        house: "Slytherin",
        dateOfBirth: null,
        yearOfBirth: 1954,
        wizard: true,
        ancestry: "pure-blood",
        eyeColour: "grey",
        hairColour: "blonde",
        wand: {
            wood: "elm",
            core: "dragon heartstring",
            length: 18,
        },
        patronus: "",
        hogwartsStudent: false,
        hogwartsStaff: false,
        actor: "Jason Isaacs",
        alternate_actors: [],
        alive: true,
        image: "https://ik.imagekit.io/hpapi/lucius.jpg",
    },
    {
        id: "04f9eb45-d843-4e29-a7d3-0bd49ed87f85",
        name: "Vincent Crabbe",
        alternate_names: [],
        species: "human",
        gender: "male",
        house: "Slytherin",
        dateOfBirth: null,
        yearOfBirth: null,
        wizard: true,
        ancestry: "pure-blood",
        eyeColour: "black",
        hairColour: "black",
        wand: {
            wood: "",
            core: "",
            length: null,
        },
        patronus: "",
        hogwartsStudent: true,
        hogwartsStaff: false,
        actor: "Jamie Waylett",
        alternate_actors: [],
        alive: false,
        image: "https://ik.imagekit.io/hpapi/crabbe.jpg",
    },
    {
        id: "a31ddc78-af12-4978-929c-3cc8a00a833e",
        name: "Gregory Goyle",
        alternate_names: [],
        species: "human",
        gender: "male",
        house: "Slytherin",
        dateOfBirth: null,
        yearOfBirth: null,
        wizard: true,
        ancestry: "pure-blood",
        eyeColour: "",
        hairColour: "brown",
        wand: {
            wood: "",
            core: "",
            length: null,
        },
        patronus: "",
        hogwartsStudent: true,
        hogwartsStaff: false,
        actor: "Josh Herdman",
        alternate_actors: [],
        alive: true,
        image: "https://ik.imagekit.io/hpapi/goyle.jpg",
    },
    {
        id: "b0620914-858d-46fc-8e6d-033c565e138b",
        name: "Mrs Norris",
        alternate_names: [],
        species: "cat",
        gender: "female",
        house: "",
        dateOfBirth: null,
        yearOfBirth: null,
        wizard: false,
        ancestry: "",
        eyeColour: "yellow",
        hairColour: "brown",
        wand: {
            wood: "",
            core: "",
            length: null,
        },
        patronus: "",
        hogwartsStudent: false,
        hogwartsStaff: true,
        actor: "Maxime, Alanis and Tommy the cats",
        alternate_actors: [],
        alive: true,
        image: "https://ik.imagekit.io/hpapi/norris.JPG",
    },
    {
      id: "2b82cfb8-0440-4a57-a030-6d75a40c0d98",
      name: "Argus Filch",
      alternate_names: [],
      species: "human",
      gender: "male",
      house: "",
      dateOfBirth: null,
      yearOfBirth: null,
      wizard: false,
      ancestry: "squib",
      eyeColour: "",
      hairColour: "grey",
      wand: {
        wood: "",
        core: "",
        length: null,
      },
      patronus: "",
      hogwartsStudent: false,
      hogwartsStaff: true,
      actor: "David Bradley",
      alternate_actors: [],
      alive: true,
      image: "https://ik.imagekit.io/hpapi/filch.jpg",
    },
  ];

// Créer une fonction retournant une liste des noms des acteurs.
const actorList = characterList.map(eachCharacter => eachCharacter.actor);


console.log(actorList)

// Créer une fonction retournant une liste des étudiants d'une maison spécifique.
const studentFilteredByHouse = (list, house) => {
    const characterIsStudent = list.filter(
      eachCharacter => eachCharacter.hogwartsStudent === true ? true : false)
    return characterFiltered = characterIsStudent.filter(
        (eachCharacter) => {
        if (house === "Gryffindor") {
            if (eachCharacter.house === "Gryffindor") {
                return true
            };
        } else if (house === "Slytherin") {
            if (eachCharacter.house === "Slytherin") {
                return true
            };
        } else if (house === "Hufflepuff") {
            if (eachCharacter.house === "Hufflepuff") {
                return true 
            };
        } else if (house === "Ravenclaw") {
            if (eachCharacter.house === "Ravenclaw") {
                return true 
            };
        }
    });
};

console.log(studentFilteredByHouse(characterList, "Slytherin"));




//retourne la liste des sorciers en vie
const wizardsAlive = (wizardsList) => wizardsList.filter(wizard => wizard.alive ? true : false);

console.log(wizardsAlive(characterList));




//retourne une liste des personnages basée sur une recherche de nom incomplet
const searchName = (wizardsList, name) => wizardsList.filter(wizard => wizard.name.includes(name) ? true :false);

console.log(searchName(characterList, "Weasley"));